/// <amd-dependency path="text!./formSection-template.html" name="formSectionTemplate" />

declare var formSectionTemplate;

class NwfFormControlsBase {
    public restrict = 'E';
    public transclude = true;
    public replace = true;
}

/* Form Control */
export class NwfFormControl extends NwfFormControlsBase implements angular.IDirective {
    static NAME: string = 'formControl';
    public template = '<dd class="l-form-control" ng-transclude></dd>';
}
export function NwfFormControlFactory(): NwfFormControl {
    return new NwfFormControl();
}


/* Form Section */
export class NwfFormSection extends NwfFormControlsBase implements angular.IDirective {
    static NAME: string = 'formSection';
    public scope = {
        title: "@"
    };
    public template = formSectionTemplate;
}
export function NwfFormSectionFactory(): NwfFormSection {
    return new NwfFormSection();
}

/**
 * @ngdoc directive
 * @name form-label directive
 * @description This directive is the implementation of a HTML5 form label
 * A form label serves the purpose of tagging a form element
 * @example <form-label><label for="policyname">Small Policy Name</label></form-label>
 *
 */

/* Form Label */
export class NwfFormLabel extends NwfFormControlsBase implements angular.IDirective {
    static NAME: string = 'formLabel';
    public template = '<dt class="l-form-label control-label" ng-transclude></dt>';
}
export function NwfFormLabelFactory(): NwfFormLabel {
    return new NwfFormLabel();
}