
class NwfFormLayoutBase {
    public restrict = 'E';
    public transclude = true;
    public replace = true;
}

/**
 * @ngdoc directive
 * @name form-row directive
 * @description This directive is the implementation a form row
 * a form row is a construct that groups a form control and it's label (form label) together so that they present a row in the form
 * @example <form-row><form-label><label for="policyname">Small Policy Name</label>
 *              </form-label><form-control><input type="text" name="policyname" id="policyname">
 *          </form-control></form-row>
 *
 */
/* Form Row */
export class NwfFormRow extends NwfFormLayoutBase implements angular.IDirective {
    static NAME: string = 'formRow';
    public template = '<dl class="l-form-row" ng-transclude></dl>';
}
export function NwfFormRowFactory(): NwfFormRow {
    return new NwfFormRow();
}



/* Inline Block Form */
export class NwfInlineBlockForm extends NwfFormLayoutBase implements angular.IDirective {
    static NAME: string = 'inlineBlockForm';
    public template = '<div class="l-inline-block-form" ng-transclude></div>';
}
export function NwfInlineBlockFormFactory(): NwfInlineBlockForm {
    return new NwfInlineBlockForm();
}

/* Inline Form */
export class NwfInlineForm extends NwfFormLayoutBase implements angular.IDirective {
    static NAME: string = 'inlineForm';
    public template = '<div class="l-inline-form" ng-transclude></div>';
}
export function NwfInlineFormFactory(): NwfInlineForm {
    return new NwfInlineForm();
}