import * as angular from 'angular';
import NwfFormElementController from './formElement-controller';
import NwfFormDirtyCheckController from './formDirtyCheck-controller';

class NwfFormValidationBase {
    public restrict = 'A';
}

// Form Element
// nwfFormElement is responsible for connecting the events to the html5 validity API
export class NwfFormElement extends NwfFormValidationBase implements angular.IDirective {
    static NAME: string = 'nwfFormElement';
    controller = NwfFormElementController;
}
export function NwfFormElementFactory(): NwfFormElement {
    return new NwfFormElement();
}

// Form Dirty Check
export class NwfFormDirtyCheck extends NwfFormValidationBase implements angular.IDirective {
    static NAME: string = 'nwfFormDirtyCheck';
    controller = NwfFormDirtyCheckController;
}
export function NwfFormDirtyCheckFactory(): NwfFormDirtyCheck {
    return new NwfFormDirtyCheck();
}