

import NwfValidator from '../nwfValidator';

class IsNumberValidatorController extends NwfValidator {

    invalidMaxMessage: string;
    invalidMinMessage: string;

    static $inject = ['$element'];

    constructor(private $element: ng.IAugmentedJQuery) {
        super($element);
        var el = $element.get(0);
        this.myEl.setAttribute('type', 'number');
    
        this.invalidMessage = this.invalidMessage || 'Please enter a number';
        this.invalidMinMessage = this.invalidMinMessage || 'Please enter a number higher than ' + el.getAttribute('min');
        this.invalidMaxMessage = this.invalidMaxMessage || 'Please enter a number lower than ' + el.getAttribute('max');
        this.emptyMessage = this.emptyMessage || 'You have to provide a value';
    }

    invalidHandler() {
        super.invalidHandler();
        if (this.myEl.validity.rangeOverflow) {
            this.myEl.setCustomValidity(this.invalidMaxMessage);
        } else if (this.myEl.validity.rangeUnderflow) {
            this.myEl.setCustomValidity(this.invalidMinMessage);
        } else {
            this.myEl.setCustomValidity('');
        }
    }
}

export class IsNumberValidator {

    static NAME: string = 'isNumber';
    bindToController = {
        emptyMessage: '@?',
        invalidMessage: '@?',
        invalidMaxMessage: '@?',
        invalidMinMessage: '@'
    };
    restrict = 'A';
    controller = IsNumberValidatorController;
    controllerAs = 'numberCtrl';
}

// export factory function
export function IsNumberValidatorFactory(): IsNumberValidator {
    return new IsNumberValidator();
}
