

import NwfValidator from '../nwfValidator';

class IsPatternValidatorController extends NwfValidator {

    static $inject = ['$element'];


    constructor(private $element: ng.IAugmentedJQuery) {
        super($element);
        this.invalidMessage = this.invalidMessage || 'This has default empty pattern';
        this.emptyMessage = this.emptyMessage || 'You have to provide a value';
    }

    invalidHandler() {
        if (this.myEl.validity.valueMissing) {
            this.myEl.setCustomValidity(this.emptyMessage);
        } else if (!this.myEl.validity.valid && this.myEl.validity.patternMismatch) {
            this.myEl.setCustomValidity(this.invalidMessage);
        } else {
            this.myEl.setCustomValidity('');
        }
        //setting 'title' attribute to empty string.
        this.myEl.setAttribute('title', '');
    }

}

export class IsPatternValidator {

    static NAME: string = 'isPattern';
    bindToController = {
        emptyMessage: '@?',
        invalidMessage: '@?'
    };
    restrict = 'A';
    controller = IsPatternValidatorController;
    controllerAs = 'patternCtrl';
}

// export factory function
export function IsPatternValidatorFactory(): IsPatternValidator {
    return new IsPatternValidator();
}
