/**
 * @ngdoc Provider
 * @name nwfConfig
 * @description
 * nwfConfig is the global Service in the NWF namespace. It can be used to get/set useful information
 * Some of the components needs nwfConfig to get Server Information and Rest EndPoints.
 * For Example look at nwf-change-password
 *
 */

/**
 * Configuration provider to set configuration data to NwfJS.
 * Every application will have its help context and can use the help directive by passing in screen specific GUID after that.
 */
export default function () {
    var helpContext: string;
    var helpContextRoot = document.location.pathname.replace('index.html', '') + "OnCommand/help/netapp/";
    var contentType: string = 'application/vnd.netapp.ocf-core.v1.hal+json';
    var registryURL: string;

    return {

        setHelpContext: function (_helpCont) {
            helpContext = _helpCont;
        },
        setHelpContextRoot: function (_helpContextRoot) {
            helpContextRoot = _helpContextRoot;
        },

        setRegistryURL: function (ru) {
            registryURL = ru;
        },

        $get: function () {
            return {
                getHelpContext: function () {
                    return helpContext;
                },
                getHelpContextRoot: function () {
                    return helpContextRoot;
                },
                getContentType: function () {
                    return contentType;
                },
                getRegistryURL: function () {
                    return registryURL;
                }
            };
        }
    };
}
