var loginInterceptor = function ($q, $injector) {
    return {
        'responseError': function (rejection) {
            console.info('Interceptor rejection:', rejection);
            /* 401 or 419 is Not Authorized */
            if (rejection.status === 401 || rejection.status === 419) {
                // Injector is used to avoid $http circular dependency if we try and use
                // dependency injection to get the authStrategy initially.
                $injector.invoke(['authStrategy',
                    function (authStrategy) {
                        authStrategy.navigateToLoginPage();
                    }
                ]);
            }
            return $q.reject(rejection);
        }
    };
};

loginInterceptor.$inject = ['$q', '$injector'];
export default loginInterceptor;
